/*
Programm: Aufg.11.1
Zweck:    Programm zum Ueben der Verwendung eines Klassen-Templates
Aufgabe:  Entspricht der Aufgabe 1 Blatt 11 der Uebungsaufgaben zur Vorlesung
          "Programmierung 3" bei Prof. Henrich im WS 2002/2003.
Autor:    Mattias Ansorg <matthias@ansorgs.de>
Lizenz:   public domain
Datum:    2002-12-03
*/

#include <iostream>
using namespace std;

class Punkt {
  public:
    Punkt(int xx, int yy):_x(xx),_y(yy){}
    void show() {
      cout << "x: " << _x
           << " y: " << _y << endl;
    }
  private:
    int _x, _y;
};


class FlaechenObj {
  public:
    FlaechenObj(Punkt bzgPunkt, int farbe=0): _bzgPunkt(bzgPunkt), _farbe(farbe){}
    virtual float flaeche() = 0;
    virtual void show() = 0;
  protected:
    Punkt _bzgPunkt;
    int _farbe;
};

class Rechteck : public FlaechenObj {
  public:
    Rechteck(Punkt bzgPunkt, int kx, int ky);
    virtual float flaeche();
    virtual void show();
  private:
    int _kx, _ky;
};

Rechteck::Rechteck(Punkt bzgPunkt, int kx, int ky)
  : FlaechenObj(bzgPunkt), _kx(kx), _ky(ky) {
}

float Rechteck::flaeche() {
  return _kx*_ky;
}

void Rechteck::show() {
  cout << "Daten des Rechtecks:" << endl
       << "  Farbe: " << _farbe << endl
       << "  Bezugspunkt: ";
  _bzgPunkt.show();
  cout << "  Kantenlnge x: " << _kx << endl
       << "  Kantenlnge y: " << _ky << endl
       << "  Flche: " << flaeche() << endl
       << endl;
}

int main() {
  FlaechenObj *myFlaechenObjPtr = new Rechteck(Punkt(1,2), 3, 4);
  myFlaechenObjPtr->show(); //zeige alle Daten und Flaeche des Rechtecks
  delete myFlaechenObjPtr;
}
